// Author: Команда #1 лицей 36 (Корнев, Чура, Кочетков)
// Result: PE at test 3
// Submitted at: 2014-11-09 13:33:08
// The contestant's actual solution begins after a blank line below

#include <iostream>

using namespace std;

void swap1(long double *a, long double *b)
{
	long double temp;
	temp = a[0];
	a[0]=b[0];
	b[0]=temp;
}
void swap1(int *a, int *b)
{
	int temp;
	temp = a[0];
	a[0]=b[0];
	b[0]=temp;
}

long double tr_search(long double starting, long double ending, int x1, int vx1, int x2, int vx2, int y1, int vy1, int y2, int vy2)
{
	long double delta1, delta2;
	long double t1, t2;
	while (ending - starting > 0.00000005)
	{
		t1 = starting + (ending - starting) / 3;
		t2 = starting + (ending - starting) * 2 / 3;
		delta1 = abs((x1+t1*vx1)*(y2+t1*vy2) - (x2 + t1*vx2)*(y1 + t1*vy1));
		delta2 = abs((x1+t2*vx1)*(y2+t2*vy2) - (x2 + t2*vx2)*(y1 + t2*vy1));
		if (delta1>delta2) starting = t1; else ending = t2;
	}
	return starting;
}

int main()
{
	int x1; int x2; int x3;
	int y1; int y2; int y3;
	int vx1; int vx2; int vx3;
	int vy1; int vy2; int vy3;
	int time;
	cin>>time;	
	cin>>x1>>y1>>vx1>>vy1;
	cin>>x2>>y2>>vx2>>vy2;
	cin>>x3>>y3>>vx3>>vy3;
	x1-=x3; x2-=x3;
	y1-=y3; y2-=y3;
	vx1-=vx3; vx2-=vx3;
	vy1-=vy3; vy2-=vy3;

	if (x1*y2==x2*y1)
	{
		cout<<0;
		return 0;
	}
	if (vx1*vy2==vy1*vx2)
	{
		long double result = tr_search(-1, time+1, x1, vx1, x2, vx2, y1, vy1, y2, vy2);
		if (result<=time && result>=0)
		{
			printf("%Lf", result);
			return 0;
		} else
		{
			cout<<-1;
			return 0;
		}
	} else
	{
		long double tx, ty;
		if (vx2==0)
		{
			swap1(&vx1, &vx2);
			swap1(&vy1, &vy2);
			swap1(&x1, &x2);
			swap1(&y1, &y2);
		}
		if (vx1==0)
		{
			long double k2 = (long double)vy2 / vx2;
			long double b2 = y2 - k2*x2;
			tx = x1;
			ty = k2 * tx + b2;
		} else
		{
			long double k1 = (long double)vy1 / vx1;
			long double b1 = y1 - k1*x1;
			long double k2 = (long double)vy2 / vx2;
			long double b2 = y2 - k2*x2;
			tx = (b2 - b1) / (k1 - k2);
			ty =  k2 * tx + b2;
		}
		long double time1 = ((tx-x1)/vx1);
		long double time2 = ((tx-x2)/vx2);
		if (time1>time2) swap1(&time1, &time2);
		long double result1, result2, result3;
		result1=result2=result3=-1;
		if (time1>0)
		{
			result1 = tr_search(-1, time1+1,  x1, vx1, x2, vx2, y1, vy1, y2, vy2);
		}
		if (time2>0)
		{
			result2 = tr_search(time1-1, time2+1,  x1, vx1, x2, vx2, y1, vy1, y2, vy2);
		}
		result3 = tr_search(time2-1, time+1,  x1, vx1, x2, vx2, y1, vy1, y2, vy2);

		if (result1<=time1 && result1>=0)
		{
			printf("%Lf", result1);
			return 0;
		} else
		{
			if (result2<=time2 && result2>=0)
			{
				printf("%Lf", result2);
				return 0;
			} else
			{
				if (result3<=time && result3>=0)
				{
					printf("%Lf", result2);
					return 0;
				} else
				{
					cout<<-1;
					return 0;
				}
			}
		}
	}
	

	return 0;
}