// Author: Сборная лицей 40 + лицей 165 (Горьков, Дроздова, Фадеева)
// Result: CE
// Submitted at: 2014-11-09 11:19:16
// Compiler output:
// Microsoft (R) 32-bit C/C++ Optimizing Compiler Version 16.00.30319.01 for 80x86
// Copyright (C) Microsoft Corporation.  All rights reserved.
// 
// src7761468589369229386.cpp
// C:\Olymp2014\compile\src7761468589369229386.cpp(4) : fatal error C1083: Cannot open include file: 'stdafx.h': No such file or directory
// 
// The contestant's actual solution begins after a blank line below

// ConsoleApplication3.cpp: определяет точку входа для консольного приложения.
//

#include "stdafx.h"
#include <iostream>
#include <math.h>
#include <cmath>

using namespace std;

const double M_PI = 3.141592653;

int n;
const double eps = 1e-9;

double angle[200001];

double less_(double a) {
	int l = 0, r = 3 * n - 1;
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (angle[m] <= a + eps)
			l = m;
		else
			r = m;
	}
	return angle[l] + 3 * M_PI - M_PI * int((angle[l] + 3 * M_PI) / M_PI);
}

double bigger(double a) {
	int l = 0, r = 3 * n - 1;
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (angle[m] < a - eps)
			l = m;
		else
			r = m;
	}
	return angle[r] + 3 * M_PI - M_PI * int((angle[r] + 3 * M_PI) / M_PI);
}

inline double len(double a1, double a2) { return min(fabs(a1 - a2), 2 * M_PI - fabs(a1 - a2)); }

double min(double a, double b, double c, double d) {
	return min(min(a, b), min(c, d));
}

double min(double a, double b, double c) {
	return min(min(a, b), c);
}

int main() {
	cout.precision(10);
	double t1, t2, t, m;
	cin >> t1 >> t2 >> t >> n;
	for (int i = 0; i < n; i++)
		cin >> angle[i + n];
	cin >> m;
	for (int i = 0; i < n; i++)
		angle[i] = angle[i + n] - 2 * M_PI;
	for (int i = 0; i < n; i++)
		angle[i + 2 * n] = angle[i + n] + 2 * M_PI;

	for (int i = 0; i < m; i++) {
		double x1, x2;
		int c1, c2;
		cin >> c1 >> x1 >> c2 >> x2;
		double bx1 = bigger(x1), bx2 = bigger(x2), lx1 = less_(x1), lx2 = less_(x2);
		double minimum;
		if (c1 == 1 && c2 == 1)
			minimum = min(
				len(x1, x2) * t1,
				(len(x2, bx2) + len(x1, lx1)) * t1 + len(bx2, lx1) * t2 + 2 * t,
				(len(x1, bx1) + len(x2, lx2)) * t1 + len(bx1, lx2) * t2 + 2 * t);
		if (c1 == 2 && c2 == 2)
			minimum = min(
				len(x1, x2) * t2,
				(len(x1, lx1) + len(x2, bx2)) * t2 + len(lx1, bx2) * t1 + 2 * t,
				(len(x1, bx1) + len(x2, lx2)) * t2 + len(bx1, lx2) * t1 + 2 * t);
		if (c1 == 2 && c2 == 1)
			minimum = min(
				len(x1, bx1) * t2 + t + len(bx1, x2) * t1,
				len(x1, lx1) * t2 + t + len(lx1, x2) * t1,
				len(x1, lx2) * t2 + t + len(lx2, x2) * t1,
				len(x1, bx2) * t2 + t + len(bx2, x2) * t1);
		if (c1 == 1 && c2 == 2)
			minimum = min(
				len(x1, bx1) * t1 + t + len(bx1, x2) * t2,
				len(x2, bx2) * t2 + t + len(bx2, x1) * t1,
				len(x1, lx1) * t1 + t + len(lx1, x2) * t2,
				len(x2, lx2) * t2 + t + len(lx2, x1) * t1);

		cout << minimum << endl;

	}

	return 0;
}

