// Author: Сборная лицей 40 + лицей 165 (Горьков, Дроздова, Фадеева)
// Result: WA at test 6
// Submitted at: 2014-11-09 11:23:34
// The contestant's actual solution begins after a blank line below


#include <iostream>
#include <math.h>
#include <cmath>

using namespace std;

const long double PI = 3.141592653;

int n;
const long double eps = 1e-9;

long double angle[200001];

long double less_(long double a) {
	int l = 0, r = 3 * n - 1;
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (angle[m] <= a + eps)
			l = m;
		else
			r = m;
	}
	return angle[l] + 3 * PI - PI * int((angle[l] + 3 * PI) / PI);
}

long double bigger(long double a) {
	int l = 0, r = 3 * n - 1;
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (angle[m] < a - eps)
			l = m;
		else
			r = m;
	}
	return angle[r] + 3 * PI - PI * int((angle[r] + 3 * PI) / PI);
}

inline long double len(long double a1, long double a2) { return min(fabs(a1 - a2), 2 * PI - fabs(a1 - a2)); }

long double min(long double a, long double b, long double c, long double d) {
	return min(min(a, b), min(c, d));
}

long double min(long double a, long double b, long double c) {
	return min(min(a, b), c);
}

int main() {
	cout.precision(10);
	long double t1, t2, t, m;
	cin >> t1 >> t2 >> t >> n;
	for (int i = 0; i < n; i++)
		cin >> angle[i + n];
	cin >> m;
	for (int i = 0; i < n; i++)
		angle[i] = angle[i + n] - 2 * PI;
	for (int i = 0; i < n; i++)
		angle[i + 2 * n] = angle[i + n] + 2 * PI;

	for (int i = 0; i < m; i++) {
		long double x1, x2;
		int c1, c2;
		cin >> c1 >> x1 >> c2 >> x2;
		long double bx1 = bigger(x1), bx2 = bigger(x2), lx1 = less_(x1), lx2 = less_(x2);
		long double minimum;
		if (c1 == 1 && c2 == 1)
			minimum = min(
				len(x1, x2) * t1,
				(len(x2, bx2) + len(x1, lx1)) * t1 + len(bx2, lx1) * t2 + 2 * t,
				(len(x1, bx1) + len(x2, lx2)) * t1 + len(bx1, lx2) * t2 + 2 * t);
		if (c1 == 2 && c2 == 2)
			minimum = min(
				len(x1, x2) * t2,
				(len(x1, lx1) + len(x2, bx2)) * t2 + len(lx1, bx2) * t1 + 2 * t,
				(len(x1, bx1) + len(x2, lx2)) * t2 + len(bx1, lx2) * t1 + 2 * t);
		if (c1 == 2 && c2 == 1)
			minimum = min(
				len(x1, bx1) * t2 + t + len(bx1, x2) * t1,
				len(x1, lx1) * t2 + t + len(lx1, x2) * t1,
				len(x1, lx2) * t2 + t + len(lx2, x2) * t1,
				len(x1, bx2) * t2 + t + len(bx2, x2) * t1);
		if (c1 == 1 && c2 == 2)
			minimum = min(
				len(x1, bx1) * t1 + t + len(bx1, x2) * t2,
				len(x2, bx2) * t2 + t + len(bx2, x1) * t1,
				len(x1, lx1) * t1 + t + len(lx1, x2) * t2,
				len(x2, lx2) * t2 + t + len(lx2, x1) * t1);

		cout << minimum << endl;

	}

	return 0;
}

